﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamComboEditor_SA_Databinding.Model
{
    public class Orchestrator : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, e);
        }


        public Orchestrator()
        {
            ListItems = new ObservableCollection<ListItem>();
            PublishTestData();
        }

        private void PublishTestData()
        {
            Item = new Item()
            {
                Name="item3",
                ListValue="value03"
            };

            ListItem listItem;
            listItem = new ListItem()
            {
                Value = "value01",
                ValDescription = "value01 | Wert 1",
                Description = "Wert 1"
            };
            ListItems.Add(listItem);

            listItem = new ListItem()
            {
                Value = "value02",
                ValDescription = "value02 | Wert 2",
                Description = "Wert 2"
            };
            ListItems.Add(listItem);

            listItem = new ListItem()
            {
                Value = "value03",
                ValDescription = "value03 | Wert 3",
                Description = "Wert 3"
            };
            ListItems.Add(listItem);

            listItem = new ListItem()
            {
                Value = "value04",
                ValDescription = "value04 | Wert 4",
                Description = "Wert 4"
            };
            ListItems.Add(listItem);
        }


        private Item _item;

        public Item Item
        {
            get { return _item; }
            set
            {
                _item = value;
                OnPropertyChanged(new PropertyChangedEventArgs(nameof(Item)));
            }
        }


        public ObservableCollection<ListItem> ListItems { get; private set; }
    }
}
